import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Worm here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Worm  extends Animal
{
    
    private int lifespan = 200;
    private int retirement = 100;
    private int age = 0;
    private int blinkPeriod = 20;
    private int extinctionRate = 12;
    private boolean extinct = false;
    
    private GreenfootImage worm1 = new GreenfootImage("worm.png");
    private GreenfootImage worm2 = new GreenfootImage("worm2.png");

    public Worm(){
        
    }

    public Worm(int life, int xRate){
        retirement = life;
        extinctionRate = xRate;
        lifespan = life * 2;
    }
    
    /**
     * Act - do whatever the Worm wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        age++;
        if(age > retirement){
            if((age % blinkPeriod) == 0){
                setImage(worm2);
            }
            if((age % (blinkPeriod*2)) == 0){
                setImage(worm1);
            }
        }
        if(age > lifespan && lifespan > 0){
            setImage(worm1);
            age = 0;
            lifespan = lifespan - (extinctionRate*2);
            retirement = retirement - extinctionRate;
            setLocation(Greenfoot.getRandomNumber(640),
            Greenfoot.getRandomNumber(480));
        }
        if(lifespan < 0 && !extinct){
            getWorld().addObject(new GameOver(), 320, 240);
            extinct = true;
        }
    }
}
