import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Font;
import java.awt.Color;

/**
 * Write a description of class DifficultyChooser here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class DifficultyChooser  extends Actor
{
    //Drawing Variables
    public Color chooseColor = new Color(100,100,100); //Grey
    public Color easyColor = new Color(0,230,0); //Green
    public Color mediumColor = new Color(255,240,0); //Yellow
    public Color hardColor = new Color(230,0,0); //Red
    public Color shadowColor = new Color(25,25,25);//Dark Grey
    public Font fnt = new Font("Arial Black", 0, 32);
    
    //Key Binding Variables
    public String easyKey = "1";
    public String mediumKey = "2";
    public String hardKey = "3";
    
    public DifficultyChooser(){
        paint();
    }

    public DifficultyChooser(String easyK, String mediumK, String hardK){
        easyKey = easyK;
        mediumKey = mediumK;
        hardKey = hardK;
        paint();
    }
    
    public void paint(){
        GreenfootImage img = new GreenfootImage(400,300);
        
        img.setFont(fnt); //Sets Font
        
        //Write Choose your Difficulty
        img.setColor(shadowColor);
        img.drawString("Choose your Difficulty",4,34);
        img.setColor(chooseColor);
        img.drawString("Choose your Difficulty",2,32);
        
        //Write easy text
        img.setColor(shadowColor);
        img.drawString("Press " + easyKey + " for Easy",59,104);
        img.setColor(easyColor);
        img.drawString("Press " + easyKey + " for Easy",57,102);
        
        //Write medium text
        img.setColor(shadowColor);
        img.drawString("Press " + mediumKey + " for Medium",34,144);
        img.setColor(mediumColor);
        img.drawString("Press " + mediumKey + " for Medium",32,142);
        
        //Write hard text
        img.setColor(shadowColor);
        img.drawString("Press " + hardKey + " for Hard",59,184);
        img.setColor(hardColor);
        img.drawString("Press " + hardKey + " for Hard",57,182);
        
        //Set's Actor Image to the image we created
        setImage(img);
    }
    
}
