import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Font;
import java.awt.Color;

/**
 * Write a description of class GameOver here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class GameOver  extends Actor
{

    private GreenfootImage img = new GreenfootImage(280,100);
    private int colorChangeDelay = 50; //Delay before new color is chosen
    private int colorChangeStep = 0;
    private int soundDelay = 50; //Delay before fail sound is played
    private int soundDelayStep = 0;
    private boolean soundPlayed = false;
    private Color textColor;

    public GameOver(){
        paint();
    }

    /**
     * Act - do whatever the GameOver wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        colorChangeStep++;
        if(colorChangeStep > colorChangeDelay){
            colorChangeStep = 0;
            textColor = new Color(
            Greenfoot.getRandomNumber(255),
            Greenfoot.getRandomNumber(255),
            Greenfoot.getRandomNumber(255));
        }
        soundDelayStep++;
        if(soundDelayStep > soundDelay && !soundPlayed){
            Greenfoot.playSound("fail.wav");
            soundPlayed = true;
        }
        paint();
    }    
    
    public void paint()
    {
        Font fnt = new Font("Arial Black",2,40);
        img.setColor(textColor);
        img.setFont(fnt);
        img.drawString("GAME OVER", 5,50);
        
        setImage(img);
    }
}
